VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4485
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   4485
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox resultsListBox 
      Height          =   4740
      ItemData        =   "Form1.frx":0000
      Left            =   720
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   480
      Width           =   3615
   End
   Begin VB.Label resultsLabel 
      Caption         =   "Results:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  efunctions example
'
'  Demonstrates the UD E-functions with the LabJack U6.
'
'  support@labjack.com
'  Jun 12, 2006
'----------------------------------------------------------------------
'

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    'long lngIOType=0, lngChannel=0
    Dim dblValue As Double
    dblValue = 0
    Dim lngValue As Long
    lngValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim TCPinOffset As Long
    TCPinOffset = 0
    Dim strError As String
    'long lngGetNextIteration
    'char ch

    Dim lngRange, lngResolution, lngBinary As Long
    Dim alngEnableTimers(5) As Long
    Dim alngEnableCounters(1), lngTimerClockBaseIndex, lngTimerClockDivisor, alngTimerModes(6) As Long
    Dim adblTimerValues(5) As Double
    Dim alngReadTimers(6), alngUpdateResetTimers(6), alngReadCounters(2), alngResetCounters(2) As Long
    Dim adblCounterValues(2) As Double
    Dim highTime, lowTime, dutyCycle As Double


    'Open the first found LabJack U6.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "1", 1, lngHandle)
    'lngError = OpenLabJack (LJ_dtU6, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Take a single-ended measurement from AIN3.
    lngRange = -1
    lngResolution = -1
    lngBinary = 0
    lngError = eAIN(lngHandle, 3, 199, dblValue, lngRange, lngResolution, -1, lngBinary, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("AIN3 = " + Str(dblValue))

    'Set DAC0 to 3.0 volts.
    dblValue = 3#
    lngBinary = 0
    lngError = eDAC(lngHandle, 0, dblValue, lngBinary, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("DAC0 set to " + Str(dblValue) + " volts")

    'Read state of FIO2.
    lngError = eDI(lngHandle, 2, lngValue)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("FIO2 = " + Str(lngValue))

    'Set the state of FIO3.
    lngValue = 0
    lngError = eDO(lngHandle, 3, lngValue)
    If lngError <> 0 Then Err.Raise lngError + 50000
    resultsListBox.AddItem ("FIO3 set to = " + Str(lngValue))
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


