VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1770
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4785
   LinkTopic       =   "Form1"
   ScaleHeight     =   1770
   ScaleWidth      =   4785
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox readListBox 
      Height          =   1425
      ItemData        =   "Form1.frx":0000
      Left            =   2160
      List            =   "Form1.frx":0002
      TabIndex        =   1
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label readLabel 
      Caption         =   "Read data:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1935
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  U6twounits.cpp
'
'  Simple example demonstrates communication with 2 U6s.
'
'  support@labjack.com
'  Feb 26, 2007
'----------------------------------------------------------------------
'

Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Form_Load()

    'On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim lngGetNextIteration As Long
    Dim dblDriverVersion As Double
    Dim lngIOType As Long
    lngIOType = 0
    Dim lngChannel As Long
    lngChannel = 0
    Dim dblValue As Double
    dblValue = 0
    Dim Value22 As Double
    Value22 = 9999
    Dim Value23 As Double
    Value23 = 9999
    Dim Value32 As Double
    Value32 = 9999
    Dim Value33 As Double
    Value33 = 9999
    Dim Value42 As Double
    Value42 = 9999
    Dim Value43 As Double
    Value43 = 9999
    Dim lngHandle2, lngHandle3 As Long


    'Open U6 with local ID 2.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "2", 0, lngHandle2)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Open the U6 with local ID 3.
    lngError = OpenLabJack(LJ_dtU6, LJ_ctUSB, "3", 0, lngHandle3)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'First a configuration command.  These will be done with the ePut
    'function which combines the add/go/get into a single call.

    'The following commands will use the add-go-get method to group
    'multiple requests into a single low-level function.

    'Request a single-ended reading from AIN2.
    lngError = AddRequest(lngHandle2, LJ_ioGET_AIN, 2, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle3, LJ_ioGET_AIN, 2, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Request a single-ended reading from AIN3.
    lngError = AddRequest(lngHandle2, LJ_ioGET_AIN, 3, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle3, LJ_ioGET_AIN, 3, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Request a reading from AIN4 using the Special 0-3.6 range.
    lngError = AddRequest(lngHandle2, LJ_ioGET_AIN_DIFF, 4, 0, 199, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle3, LJ_ioGET_AIN_DIFF, 4, 0, 199, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Execute all requests on all open LabJacks.
    lngError = Go()
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results for unit 2.  The input measurement results are stored.
    lngError = GetFirstResult(lngHandle2, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    lngGetNextIteration = 0 'Used by the error handling function.

    While lngError < LJE_MIN_GROUP_ERROR
        Select Case lngIOType

            Case LJ_ioGET_AIN:
                Select Case (lngChannel)
                    Case 2: Value22 = dblValue
                    Case 3: Value32 = dblValue
                End Select
    
            Case LJ_ioGET_AIN_DIFF:
                Value42 = dblValue
            
        End Select

        lngError = GetNextResult(lngHandle2, lngIOType, lngChannel, dblValue, 0, 0)
        If (Not lngError = LJE_NO_MORE_DATA_AVAILABLE) And lngError <> 0 Then Err.Raise lngError + 50000

    Wend

    'Get all the results for unit 3.  The input measurement results are stored.
    lngError = GetFirstResult(lngHandle3, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    lngGetNextIteration = 0 'Used by the error handling function.

    While (lngError < LJE_MIN_GROUP_ERROR)
        Select Case lngIOType
        
            Case LJ_ioGET_AIN:
                Select Case (lngChannel)
                    Case 2: Value23 = dblValue
                    Case 3: Value33 = dblValue
                End Select
    
            Case LJ_ioGET_AIN_DIFF:
                Value43 = dblValue
            
        End Select

        lngError = GetNextResult(lngHandle3, lngIOType, lngChannel, dblValue, 0, 0)
    Wend


    readListBox.AddItem ("AIN2 (Unit 2) = " + Str(Value22))
    readListBox.AddItem ("AIN2 (Unit 3) = " + Str(Value23))
    readListBox.AddItem ("AIN3 (Unit 2) = " + Str(Value32))
    readListBox.AddItem ("AIN3 (Unit 3) = " + Str(Value33))
    readListBox.AddItem ("AIN4 (Unit 2) = " + Str(Value42))
    readListBox.AddItem ("AIN4 (Unit 3) = " + Str(Value43))
    
ErrorMessage:
    Dim strError As String
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
