VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5370
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5880
   LinkTopic       =   "Form1"
   ScaleHeight     =   5370
   ScaleWidth      =   5880
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtBRH 
      Height          =   285
      Left            =   2040
      TabIndex        =   20
      Text            =   "0.0"
      Top             =   4200
      Width           =   1455
   End
   Begin VB.TextBox txtBTempF 
      Height          =   285
      Left            =   2040
      TabIndex        =   18
      Text            =   "0.0"
      Top             =   3480
      Width           =   1455
   End
   Begin VB.TextBox txtBTempC 
      Height          =   285
      Left            =   2040
      TabIndex        =   16
      Text            =   "0.0"
      Top             =   2760
      Width           =   1455
   End
   Begin VB.TextBox txtBTempK 
      Height          =   285
      Left            =   2040
      TabIndex        =   14
      Text            =   "0.0"
      Top             =   2040
      Width           =   1455
   End
   Begin VB.TextBox txtARH 
      Height          =   285
      Left            =   120
      TabIndex        =   12
      Text            =   "0.0"
      Top             =   4200
      Width           =   1455
   End
   Begin VB.TextBox txtATempF 
      Height          =   285
      Left            =   120
      TabIndex        =   10
      Text            =   "0.0"
      Top             =   3480
      Width           =   1455
   End
   Begin VB.TextBox txtATempC 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0.0"
      Top             =   2760
      Width           =   1455
   End
   Begin VB.TextBox txtATempK 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Text            =   "0.0"
      Top             =   2040
      Width           =   1455
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "0"
      Top             =   1080
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1080
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0"
      Top             =   480
      Width           =   1095
   End
   Begin VB.Label Label11 
      Caption         =   "ProbeB RH"
      Height          =   495
      Left            =   2040
      TabIndex        =   21
      Top             =   3960
      Width           =   1215
   End
   Begin VB.Label Label10 
      Caption         =   "ProbeB TempF"
      Height          =   495
      Left            =   2040
      TabIndex        =   19
      Top             =   3240
      Width           =   1215
   End
   Begin VB.Label Label9 
      Caption         =   "ProbeB TempC"
      Height          =   495
      Left            =   2040
      TabIndex        =   17
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label8 
      Caption         =   "ProbeB TempK"
      Height          =   495
      Left            =   2040
      TabIndex        =   15
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label Label7 
      Caption         =   "ProbeA RH %"
      Height          =   495
      Left            =   120
      TabIndex        =   13
      Top             =   3960
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "ProbeA TempF"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   3240
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "ProbeA TempC"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "ProbeA TempK"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   5
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'VB6 example to interface 1 or 2 EI-1050 probes.
'support@labjack.com
'Jul 13, 2006

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngErrorcode As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim strError As String * 256
    
    On Error GoTo ErrorMessage
    
    Dim lngSingleProbe As Long
    
    lngSingleProbe = 1  '1=TRUE=Single Probe, 0=FALSE=Two Probes
        
        
    'Open the first found LabJack UE9 over USB.
    lngErrorcode = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'Open the LabJack UE9 over Ethernet.
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngErrorcode)
    'Convert the error code to a string.
    ErrorToString lngErrorcode, strError
    txtOpenErrorString = strError
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    

    'Set the Data line to FIO0, which is the default anyway.
    lngErrorcode = ePut(lngHandle, LJ_ioSHT_DATA_CHANNEL, 0, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set the Clock line to FIO1, which is the default anyway.
    lngErrorcode = ePut(lngHandle, LJ_ioSHT_CLOCK_CHANNEL, 1, 0, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Set FIO2 to output-high to provide power to the EI-1050s.
    lngErrorcode = ePut(lngHandle, LJ_ioPUT_DIGITAL_BIT, 2, 1, 0)
    If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"



    If lngSingleProbe Then
    
        'Use this code if only a single EI-1050 is connected.
        '  Connections for the probe:
        '  Red (Power)         FIO2
        '  Black (Ground)      GND
        '  Green (Data)        FIO0
        '  White (Clock)       FIO1
        '  Brown (Enable)      FIO2

        'Now, an add/go/get block to get the temp & humidity at the same time.
        'Request a temperature reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Request a humidity reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Execute the requests.  Will take about 0.5 seconds with a USB high-high
        'or Ethernet connection, and about 1.5 seconds with a normal USB connection.
        lngErrorcode = GoOne(lngHandle)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Get the temperature reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtATempK = Str(dblValue)
        txtATempC = Str(dblValue - 273.15)
        txtATempF = Str(((dblValue - 273.15) * 1.8) + 32)

        'Get the humidity reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtARH = Str(dblValue)

        'End of single probe code.


    Else
    
    
        'Use this code if two EI-1050 probes are connected.
        '  Connections for both probes:
        '  Red (Power)         FIO2
        '  Black (Ground)      GND
        '  Green (Data)        FIO0
        '  White (Clock)       FIO1
        '
        '  Probe A:
        '  Brown (Enable)    FIO3
        '
        '  Probe B:
        '  Brown (Enable)    DAC0

        'Set FIO3 to output-low to disable probe A.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DIGITAL_BIT, 3, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Set DAC0 to 0 volts to disable probe B.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DAC, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"




        'Set FIO3 to output-high to enable probe A.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DIGITAL_BIT, 3, 1, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Now, an add/go/get block to get the temp & humidity at the same time.
        'Request a temperature reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Request a humidity reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Execute the requests.  Will take about 0.5 seconds with a USB high-high
        'or Ethernet connection, and about 1.5 seconds with a normal USB connection.
        lngErrorcode = GoOne(lngHandle)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Get the temperature reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtATempK = Str(dblValue)
        txtATempC = Str(dblValue - 273.15)
        txtATempF = Str(((dblValue - 273.15) * 1.8) + 32)

        'Get the humidity reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtARH = Str(dblValue)

        'Set FIO3 to output-low to disable probe A.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DIGITAL_BIT, 3, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"




        'Set DAC0 to 3.3 volts to enable probe B.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DAC, 0, 3.3, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
        'Now, an add/go/get block to get the temp & humidity at the same time.
        'Request a temperature reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Request a humidity reading from the EI-1050.
        lngErrorcode = AddRequest(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Execute the requests.  Will take about 0.5 seconds with a USB high-high
        'or Ethernet connection, and about 1.5 seconds with a normal USB connection.
        lngErrorcode = GoOne(lngHandle)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

        'Get the temperature reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_TEMP, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtBTempK = Str(dblValue)
        txtBTempC = Str(dblValue - 273.15)
        txtBTempF = Str(((dblValue - 273.15) * 1.8) + 32)

        'Get the humidity reading.
        lngErrorcode = GetResult(lngHandle, LJ_ioSHT_GET_READING, LJ_chSHT_RH, dblValue)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        txtBRH = Str(dblValue)

        'Set DAC0 to 0 volts to disable probe B.
        lngErrorcode = ePut(lngHandle, LJ_ioPUT_DAC, 0, 0, 0)
        If lngErrorcode <> 0 Then Err.Raise lngErrorcode + 50000 ''Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
        'End of dual probe code.
    
    
    End If
    
    Exit Sub

        


ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
        
        
End Sub


