VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4740
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7995
   LinkTopic       =   "Form1"
   ScaleHeight     =   4740
   ScaleWidth      =   7995
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtNumFound 
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Text            =   "0"
      Top             =   1800
      Width           =   1095
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   2655
      Left            =   1800
      TabIndex        =   2
      Top             =   360
      Width           =   3735
      _ExtentX        =   6588
      _ExtentY        =   4683
      _Version        =   393216
      Rows            =   4
      Cols            =   3
      FixedRows       =   0
      FixedCols       =   0
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label5 
      Caption         =   "Number Found"
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   1560
      Width           =   1575
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'VB example calls the ListAll function from the UD driver.
'support@labjack.com
'Aug 23, 2006

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit


Private Sub Form_Load()
    
    Dim lngHandle As Long
    Dim lngError As Long
    Dim i As Long
    Dim NumFound As Long
    Dim dblDriverVersion As Double
    Dim strError As String * 256
    Dim alngSerialNumbers(128) As Long
    Dim alngLocalIDs(128) As Long
    Dim adblAddresses(128) As Double
        
    On Error GoTo ErrorMessage
    
    'Initialize the arrays so it will be easy to tell if the values have changed
    For i = 1 To 128
        alngSerialNumbers(i) = 9999
        alngLocalIDs(i) = 9999
        adblAddresses(i) = 9999
    Next i
    
    'Initialize FlexGrid Indicator
    MSFlexGrid1.FixedCols = 0
    MSFlexGrid1.FixedRows = 0
    MSFlexGrid1.Cols = 3
    MSFlexGrid1.Rows = 11
    MSFlexGrid1.Row = 0
    MSFlexGrid1.Col = 0
    MSFlexGrid1.Text = "SerialNumbers"
    MSFlexGrid1.Col = 1
    MSFlexGrid1.Text = "LocalIDs"
    MSFlexGrid1.Col = 2
    MSFlexGrid1.Text = "Addresses"

        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
    lngError = ListAll(LJ_dtUE9, LJ_ctUSB, NumFound, alngSerialNumbers(0), alngLocalIDs(0), adblAddresses(0))
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Display the number found.
    txtNumFound = Str(NumFound)
      
    'Display the first 10 elements on a FlexGrid component.
    For i = 0 To 9
        MSFlexGrid1.Row = i + 1
        MSFlexGrid1.Col = 0
        MSFlexGrid1.Text = Str(alngSerialNumbers(i))
        MSFlexGrid1.Col = 1
        MSFlexGrid1.Text = Str(alngLocalIDs(i))
        MSFlexGrid1.Col = 2
        MSFlexGrid1.Text = Str(adblAddresses(i))
        'MSFlexGrid1.Text = Format(adblAddresses(i), "#.####")
    Next i
    
     
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    Exit Sub
        
End Sub

