VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7740
   LinkTopic       =   "Form1"
   ScaleHeight     =   6615
   ScaleWidth      =   7740
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCalMemRead1 
      Height          =   285
      Left            =   2760
      TabIndex        =   14
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtCalMemWrite 
      Height          =   285
      Left            =   2760
      TabIndex        =   13
      Text            =   "0"
      Top             =   3840
      Width           =   1095
   End
   Begin VB.TextBox txtCalMemRead2 
      Height          =   285
      Left            =   2760
      TabIndex        =   12
      Text            =   "0"
      Top             =   4560
      Width           =   1095
   End
   Begin VB.TextBox txtUserMemRead2 
      Height          =   285
      Left            =   120
      TabIndex        =   10
      Text            =   "0"
      Top             =   4560
      Width           =   1095
   End
   Begin VB.TextBox txtUserMemWrite 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0"
      Top             =   3840
      Width           =   1095
   End
   Begin VB.TextBox txtUserMemRead1 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "0"
      Top             =   2160
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label9 
      Caption         =   "CalMem Initial Read Value127"
      Height          =   495
      Left            =   2760
      TabIndex        =   17
      Top             =   2880
      Width           =   2295
   End
   Begin VB.Label Label8 
      Caption         =   "CalMem Write Value127"
      Height          =   495
      Left            =   2760
      TabIndex        =   16
      Top             =   3600
      Width           =   1935
   End
   Begin VB.Label Label7 
      Caption         =   "CalMem Final Read Value127"
      Height          =   495
      Left            =   2760
      TabIndex        =   15
      Top             =   4320
      Width           =   2295
   End
   Begin VB.Label Label5 
      Caption         =   "UserMem Final Read Byte0"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   4320
      Width           =   2055
   End
   Begin VB.Label Label4 
      Caption         =   "UserMem Write Byte0"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   3600
      Width           =   1575
   End
   Begin VB.Label Label6 
      Caption         =   "UserMem Initial Read Byte0"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   2880
      Width           =   2055
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   5
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Demonstrates writing and reading to the user and cal memory on the UE9.

'Tested with UD driver V2.66, and Comm/Control firmware 1.39/1.66.

'support@labjack.com
'Jan 11, 2007

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim strError As String * 256
    Dim dblTimer1 As Double
    Dim dblTimer2 As Double
    Dim dblTimer3 As Double
    Dim dutyCycle As Double
    Dim highTicks As Double
    Dim abytUserMem(1024) As Byte
    Dim adblCalMem(128) As Double
        
    
    On Error GoTo ErrorMessage
        
    'Seed the VB random number generator.
    Randomize
       
    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'Open the LabJack UE9 over Ethernet.
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    
    'Read the user memory.
    lngError = eGet_ByRef(lngHandle, LJ_ioGET_CONFIG, LJ_chUSER_MEM, 0, abytUserMem(0))
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The user memory has 1024 bytes, but here we just display the first.
    txtUserMemRead1 = Str(abytUserMem(0))
    
    'Modify the first byte in the array, without changing the rest.
    abytUserMem(0) = 100 * Rnd
    txtUserMemWrite = Str(abytUserMem(0))
    
    'Write the user memory.  We are only changing the first byte.
    lngError = eGet_ByRef(lngHandle, LJ_ioPUT_CONFIG, LJ_chUSER_MEM, 0, abytUserMem(0))
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Read the user memory again.
    lngError = eGet_ByRef(lngHandle, LJ_ioGET_CONFIG, LJ_chUSER_MEM, 0, abytUserMem(0))
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The user memory has 1024 bytes, but here we just display the first.
    txtUserMemRead2 = Str(abytUserMem(0))
    
    
    
    
    'Now a cal constants example.  The calibration memory is passed as doubles.
    'The memory area consists of 8 blocks (0-7) of 16 doubles each, for a total
    'of 128 elements.  As of this writing, block 7 is not used, so we will
    'use the last 4 elements of block 7 for testing, which is elements 124-127.
    'We will read the constants, update a few elements, and write the constants.
    'The entire memory area is read and written each time.
    
    'This cal example is commented out by default, as writing and reading
    'the cal area is an advanced operation.
    
    'Read the cal memory.
    'lngError = eGet_ByRef(lngHandle, LJ_ioGET_CONFIG, LJ_chCAL_CONSTANTS, 0, adblCalMem(0))
    'If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The cal memory has 128 values, but here we just display the last.
    'txtCalMemRead1 = Str(adblCalMem(127))
    
    'Modify the last value in the array, without changing the rest.
    'adblCalMem(127) = 10000 * Rnd
    'txtCalMemWrite = Str(adblCalMem(127))
    
    'Write the cal constants.  We are only changing the last value.
    'lngError = eGet_ByRef(lngHandle, LJ_ioPUT_CONFIG, LJ_chCAL_CONSTANTS, 19564, adblCalMem(0))
    'If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Read the cal memory again.
    'lngError = eGet_ByRef(lngHandle, LJ_ioGET_CONFIG, LJ_chCAL_CONSTANTS, 0, adblCalMem(0))
    'If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The cal memory has 128 values, but here we just display the last.
    'txtCalMemRead2 = Str(adblCalMem(127))
    
  
  
  
        
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


