VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4905
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   11715
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   11715
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCommBacklog 
      Height          =   285
      Left            =   2400
      TabIndex        =   16
      Text            =   "0"
      Top             =   4200
      Width           =   1095
   End
   Begin MSFlexGridLib.MSFlexGrid MSFlexGrid1 
      Height          =   3975
      Left            =   4560
      TabIndex        =   15
      Top             =   600
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   7011
      _Version        =   393216
      Rows            =   4
      Cols            =   7
      FixedRows       =   0
      FixedCols       =   0
   End
   Begin VB.TextBox txtActualScanRate 
      Height          =   285
      Left            =   120
      TabIndex        =   13
      Text            =   "0.0"
      Top             =   2880
      Width           =   1095
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   240
      Top             =   4080
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   615
      Left            =   2400
      TabIndex        =   12
      Top             =   600
      Width           =   1455
   End
   Begin VB.TextBox txtNumScansReturned 
      Height          =   285
      Left            =   2400
      TabIndex        =   10
      Text            =   "0"
      Top             =   3600
      Width           =   1095
   End
   Begin VB.TextBox txtNumScansRequested 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0"
      Top             =   3600
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Text            =   "0"
      Top             =   2160
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   960
      Width           =   1095
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label5 
      Caption         =   "Comm Backlog"
      Height          =   495
      Left            =   2400
      TabIndex        =   17
      Top             =   3960
      Width           =   1575
   End
   Begin VB.Label Label8 
      Caption         =   "Actual Scan Rate"
      Height          =   495
      Left            =   120
      TabIndex        =   14
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label Label4 
      Caption         =   "# Scans Returned"
      Height          =   495
      Left            =   2400
      TabIndex        =   11
      Top             =   3360
      Width           =   1575
   End
   Begin VB.Label Label6 
      Caption         =   "# Scans Requested"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   3360
      Width           =   1695
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   720
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'VB example uses the LabJackUD driver to do a stream with 2 analog input
'channels plus 2 quadrature timer channels.
'support@labjack.com
'10/5/2005

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Const scanRate = 1000
Const readInterval = 500  'millisecond interval to read stream data

'Set the number of scans to read.  We will request twice the number
'we expect, to make sure we get everything that is available.  So
'with scanRate=1000 and readInterval=500, we expect 500 scans (3000
'samples) per read, and will request up to 1000 scans (6000 samples)
'per read.  If you run this program and see that you are, on average,
'reading less than 500 scans/s, it means VB is too slow and not
'calling the read function at the specified interval.
Const numScansRequested = 2 * scanRate * (readInterval / 1000)
Const numSamplesRequested = 6 * numScansRequested  'we are doing a 6-channel scan

'Number of scans to display on a FlexGrid component.  VB is too slow
'to display all the scans.
Const numScansToDisplay = 2

'Global Variables
Dim lngHandle As Long



Private Sub Form_Load()
    
    Dim lngError As Long
    Dim i As Long
    Dim dblDriverVersion As Double
    Dim strError As String * 256
    Dim dblAIN0 As Double
    Dim dblAIN1 As Double
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
        
    On Error GoTo ErrorMessage
    
    'Initialize FlexGrid Indicator
    MSFlexGrid1.FixedCols = 0
    MSFlexGrid1.FixedRows = 0
    MSFlexGrid1.Cols = 7
    MSFlexGrid1.Rows = numScansToDisplay
    MSFlexGrid1.Col = 0
    For i = 0 To numScansToDisplay - 1
        MSFlexGrid1.Row = i
        MSFlexGrid1.Text = Str(i)
    Next i
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
      
    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, 1, 1, lngHandle)
    'Open the LabJack UE9 over Ethernet.
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Enable 4 timers for the two quadrature channels.  They will use FIO0/FIO1 and FIO2/FIO3.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer0 as Quad.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmQUAD, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer1 as Quad.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmQUAD, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer2 as Quad.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 2, LJ_tmQUAD, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer3 as Quad.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 3, LJ_tmQUAD, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Execute the list of requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    While lngError = 0
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    Wend
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
     
     
    'Configure the stream:
    'Configure analog inputs for 12-bit resolution
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, 12, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure the analog input range on channels 0 and 1 for bipolar +-5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_AIN_RANGE, 0, LJ_rgBIP5V, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioPUT_AIN_RANGE, 1, LJ_rgBIP5V, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the scan rate.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_SCAN_FREQUENCY, scanRate, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Give the driver a 5 second buffer (scanRate * 2 channels * 5 seconds).
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_BUFFER_SIZE, scanRate * 2 * 5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure reads to retrieve whatever data is available without waiting.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chSTREAM_WAIT_MODE, LJ_swNONE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Define the scan list.
    lngError = AddRequest(lngHandle, LJ_ioCLEAR_STREAM_CHANNELS, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 1, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 200, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 224, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 202, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioADD_STREAM_CHANNEL, 224, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Execute the list of requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    While lngError = 0
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    Wend
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Start the stream.
    lngError = eGet(lngHandle, LJ_ioSTART_STREAM, 0, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The actual scan rate is dependent on how the desired scan rate
    'divides into the LabJack clock.  The actual scan rate is returned
    'in the value parameter from the start stream command.
    txtActualScanRate = Format(dblValue, "#.###")
    
    'Enable the VB timer that triggers the read function
    Timer1.Interval = readInterval
    Timer1.Enabled = True
    
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    Exit Sub
        
End Sub
    
    
  

Private Sub Timer1_Timer()

    Dim i As Long
    Dim dblValue As Double
    Dim lngError As Long
    Dim strError As String * 256
    Dim adblData(numSamplesRequested) As Double
    
    On Error GoTo ErrorMessage

    'Initialize the array so it will be easy to tell if the values have changed
    For i = 1 To numSamplesRequested
        adblData(i) = 9999
    Next i
        
    'Note that the array we pass must be sized to hold enough SAMPLES, and
    'the Value we pass specifies the number of SCANS to read.
    dblValue = numScansRequested
    txtNumScansRequested = Str(dblValue)
    
    'Read the data.  The special functions AddReqest_ByRef or eGet_ByRef
    'must be used since we are retrieving an array.
    'By passing the first element of the array, we are giving the
    'LabJackUD DLL a pointer to the array.  Since each sample uses 8 bytes, you
    'should probably keep the array to 8000 samples or less to stay under 64k in size in RAM.
    lngError = eGet_ByRef(lngHandle, LJ_ioGET_STREAM_DATA, LJ_chALL_CHANNELS, dblValue, adblData(0))
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtNumScansReturned = Str(dblValue)
    
    'Display some scans on a FlexGrid component.
    For i = 0 To numScansToDisplay - 1
        MSFlexGrid1.Row = i
        MSFlexGrid1.Col = 1
        MSFlexGrid1.Text = Format(adblData(6 * i), "#.####")
        MSFlexGrid1.Col = 2
        MSFlexGrid1.Text = Format(adblData(1 + (6 * i)), "#.####")
        MSFlexGrid1.Col = 3
        MSFlexGrid1.Text = Format(adblData(2 + (6 * i)), "#.####")
        MSFlexGrid1.Col = 4
        MSFlexGrid1.Text = Format(adblData(3 + (6 * i)), "#.####")
        MSFlexGrid1.Col = 5
        MSFlexGrid1.Text = Format(adblData(4 + (6 * i)), "#.####")
        MSFlexGrid1.Col = 6
        MSFlexGrid1.Text = Format(adblData(5 + (6 * i)), "#.####")
    Next i
    
    'Retrieve the current Comm backlog.  The UD driver retrieves stream data from
    'the UE9 in the background, but if the computer is too slow for some reason
    'the driver might not be able to read the data as fast as the UE9 is
    'acquiring it, and thus there will be data left over in the UE9 buffer.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chSTREAM_BACKLOG_COMM, dblValue, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtCommBacklog = Str(dblValue)
   
    Exit Sub
    
        
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    'Disable the VB timer that triggers the read function
    Timer1.Enabled = False
    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    Exit Sub
    
End Sub



Private Sub cmdStop_Click()
    Dim lngError As Long
    Dim strError As String * 256
    
    On Error GoTo ErrorMessage

    'Disable the VB timer that triggers the read function
    Timer1.Enabled = False

    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    Exit Sub
        
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    Exit Sub
End Sub



Private Sub Form_Terminate()
    Dim lngError As Long
    
    'Disable the VB timer that triggers the read function
    Timer1.Enabled = False

    'Stop the stream
    lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    'Disable the timers.
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0)
    
End Sub



