VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5415
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7740
   LinkTopic       =   "Form1"
   ScaleHeight     =   5415
   ScaleWidth      =   7740
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtSerialNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   14
      Text            =   "0"
      Top             =   2760
      Width           =   1335
   End
   Begin VB.TextBox txtCount1 
      Height          =   285
      Left            =   120
      TabIndex        =   12
      Text            =   "0"
      Top             =   4800
      Width           =   1095
   End
   Begin VB.TextBox txtFIO6 
      Height          =   285
      Left            =   120
      TabIndex        =   10
      Text            =   "0"
      Top             =   4080
      Width           =   1095
   End
   Begin VB.TextBox txtAIN1 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0.0"
      Top             =   3360
      Width           =   1935
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   6
      Text            =   "0"
      Top             =   2160
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "0"
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label7 
      Caption         =   "Serial Number"
      Height          =   495
      Left            =   120
      TabIndex        =   15
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Count1"
      Height          =   495
      Left            =   120
      TabIndex        =   13
      Top             =   4560
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "FIO6"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   3840
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "AIN1"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   3120
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   7
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Simple VB example uses the LabJackUD driver to communicate with a U3 using eFunctions.
'support@labjack.com
'Aug 4, 2008

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    Dim dblDriverVersion As Double
    Dim strError As String * 256
    Dim dblSerialNumber As Double
    Dim dblAIN1 As Double
    Dim dblFIO6 As Long
    
    Dim aEnableTimers(2) As Long
    Dim aEnableCounters(2) As Long
    Dim TCPinOffset As Long
    Dim TimerClockBaseIndex As Long
    Dim TimerClockDivisor As Long
    Dim aTimerModes(2) As Long
    Dim aTimerValues(2) As Double
    Dim aReadTimers(2) As Long
    Dim aUpdateResetTimers(2) As Long
    Dim aReadCounters(2) As Long
    Dim aResetCounters(2) As Long
    Dim aCounterValues(2) As Double
        
        
    On Error GoTo ErrorMessage
        
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
   
    'Open the first found LabJack U3 over USB.
    lngError = OpenLabJack(LJ_dtU3, LJ_ctUSB, "1", 1, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Start by using the pin_configuration_reset IOType so that all
    'pin assignments are in the factory default condition.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Read the serial number using eGet():
    'Read and display the serial number.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chSERIAL_NUMBER, dblSerialNumber, 0)
    txtSerialNumber = Str(dblSerialNumber)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get a reading from AIN1.  For a single-ended reading, pass ChannelN=31.
    lngError = eAIN(lngHandle, 1, 31, dblAIN1, 0, 0, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Get the state of FIO6.
    lngError = eDI(lngHandle, 6, dblFIO6)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Set DAC0 to 2.5 volts.
    lngError = eDAC(lngHandle, 0, 2.5, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Set the state of FIO7 to output-high.
    lngError = eDO(lngHandle, 7, 1)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    txtAIN1 = Format(dblAIN1, "#.#####")
    txtFIO6 = Str(dblFIO6)
        
             
    'Now a timer and counter example.  Connect a jumper
    'from FIO4 (PWM output) to FIO5 (Counter1 input).
    'Use the 48MHZ_DIV timer clock base, meaning that the clock
    'divisor option is available, but Counter0 is not available.
    aEnableTimers(0) = 1  'Enable Timer0
    aEnableTimers(1) = 0
    aEnableCounters(0) = 0
    aEnableCounters(1) = 1  'Enable Counter1
    TCPinOffset = 4  'Timer0 on FIO4
    TimerClockBaseIndex = LJ_tc48MHZ_DIV
    TimerClockDivisor = 14  'PWM16 frequency = (48M/65536)/14 = 52.3 Hz
    aTimerModes(0) = LJ_tmPWM16  'Timer0 = 16-bit PWM
    aTimerValues(0) = 32768  'Initial duty-cycle = 50%
    'Here is the actual call.  Arrays are passed by passing the first element by reference.  This gives the
    'LabJackUD DLL a pointer to the array.
    lngError = eTCConfig(lngHandle, aEnableTimers(0), aEnableCounters(0), TCPinOffset, TimerClockBaseIndex, TimerClockDivisor, aTimerModes(0), aTimerValues(0), 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    'Wait half a second, then read Counter1.  Should get roughly 26 counts.
    'We will also update the PWM with a new duty-cycle of 1 ms.  The period of
    'our PWM is about 1/52.3 = 19.1 ms, so 1 ms is 5.2%.  That means we
    'want 94.8% low which is a value of 0.948*65536 = 62107.
    Sleep 500
    aReadTimers(0) = 1  'We actually don't need to read Timer0, but UD V2.75 or less does not update unless a read is done.
    aUpdateResetTimers(0) = 1  'Update  value of Timer0
    aReadCounters(1) = 1  'Read Counter1
    aResetCounters(1) = 0  'Don't reset the counter
    aTimerValues(0) = 62107  'Set duty-cycle to 1 ms
    lngError = eTCValues(lngHandle, aReadTimers(0), aUpdateResetTimers(0), aReadCounters(0), aResetCounters(0), aTimerValues(0), aCounterValues(0), 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtCount1 = Str(aCounterValues(1))
    
        
    'Disable the timer and counter.
    lngError = ePut(lngHandle, LJ_ioPIN_CONFIGURATION_RESET, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


