VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4005
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8475
   LinkTopic       =   "Form1"
   ScaleHeight     =   4005
   ScaleWidth      =   8475
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox dutyTwoDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":0000
      Left            =   6000
      List            =   "Form1.frx":0002
      TabIndex        =   11
      Top             =   2760
      Width           =   2175
   End
   Begin VB.ListBox dutyOneDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":0004
      Left            =   1800
      List            =   "Form1.frx":0006
      TabIndex        =   9
      Top             =   2760
      Width           =   2175
   End
   Begin VB.ListBox lowTwoDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":0008
      Left            =   6000
      List            =   "Form1.frx":000A
      TabIndex        =   7
      Top             =   1440
      Width           =   2175
   End
   Begin VB.ListBox lowOneDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":000C
      Left            =   1800
      List            =   "Form1.frx":000E
      TabIndex        =   5
      Top             =   1440
      Width           =   2175
   End
   Begin VB.ListBox highTwoDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":0010
      Left            =   6000
      List            =   "Form1.frx":0012
      TabIndex        =   3
      Top             =   240
      Width           =   2175
   End
   Begin VB.ListBox highOneDisplay 
      Height          =   1035
      ItemData        =   "Form1.frx":0014
      Left            =   1800
      List            =   "Form1.frx":0016
      TabIndex        =   1
      Top             =   120
      Width           =   2175
   End
   Begin VB.Label dutyCycleTwo 
      Caption         =   "Duty Cycle Timer 2:"
      Height          =   255
      Left            =   4320
      TabIndex        =   10
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label dutyOneLabel 
      Caption         =   "Duty Cycle Timer 1:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   2640
      Width           =   1575
   End
   Begin VB.Label lowTwoLabel 
      Caption         =   "Low Clicks Timer 2:"
      Height          =   255
      Left            =   4320
      TabIndex        =   6
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label lowOneLabel 
      Caption         =   "Low Clicks Timer 1:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1320
      Width           =   1575
   End
   Begin VB.Label highTwoLabel 
      Caption         =   "High Clicks Timer 2:"
      Height          =   255
      Left            =   4320
      TabIndex        =   2
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label highOneLabel 
      Caption         =   "High Clicks Timer 1:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
'
'  PWMDutyCycle example
'
'  Demonstrates 1 PWM output and 2 duty cycle inputs.
'  Connect FIO0 to FIO1 to FIO2.
'
'  support@labjack.com
'  July 7, 2009
'----------------------------------------------------------------------
'

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

    Private Const OFFSET_4 = 4294967296#
    Private Const MAXINT_4 = 2147483647
    Private Const OFFSET_2 = 65536
    Private Const MAXINT_2 = 32767

    Function UnsignedToLong(Value As Double) As Long
        If Value < 0 Or Value >= OFFSET_4 Then Error 6 ' Overflow
        If Value <= MAXINT_4 Then
          UnsignedToLong = Value
        Else
          UnsignedToLong = Value - OFFSET_4
        End If
    End Function

Private Function ReadDutyCycle(ByVal lngHandle As Long, ByVal timerNumber As Integer) As Long

    Dim dblValue As Double
    dblValue = 0
    Dim lngError As Long
    Dim highTime, lowTime, dutyCycle As Double

    'Read from Timer.  We will go ahead and reset the timer (by writing
    'a value of 0) at the same time as the read.  This way if no new
    'edges occur (e.g. 0% or 100% duty cycle) the next read will return
    'the preset high/low times (0/65535 or 65535/0) rather than returning
    'the old values.
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, timerNumber, 0, 0, 0)
    If lngError <> 0 Then
        ReadDutyCycle = lngError
        Exit Function
    End If
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, timerNumber, 0, 0, 0)
     If lngError <> 0 Then
        ReadDutyCycle = lngError
        Exit Function
    End If
    lngError = GoOne(lngHandle)
     If lngError <> 0 Then
        ReadDutyCycle = lngError
        Exit Function
    End If
    lngError = GetResult(lngHandle, LJ_ioPUT_TIMER_VALUE, timerNumber, 0)  'just to check for error
     If lngError <> 0 Then
        ReadDutyCycle = lngError
        Exit Function
    End If
    lngError = GetResult(lngHandle, LJ_ioGET_TIMER, timerNumber, dblValue)
     If lngError <> 0 Then
        ReadDutyCycle = lngError
        Exit Function
    End If
    'High time is LSW
    highTime = UnsignedToLong(dblValue) Mod 65536
    'Low time is MSW
    lowTime = UnsignedToLong(dblValue) / 65536
    'Calculate the duty cycle percentage.
    dutyCycle = 100 * highTime / (highTime + lowTime)

    If timerNumber = 1 Then
        highOneDisplay.AddItem (highTime)
    ElseIf timerNumber = 2 Then
        highTwoDisplay.AddItem (highTime)
    End If
    
    If timerNumber = 1 Then
        lowOneDisplay.AddItem (lowTime)
    ElseIf timerNumber = 2 Then
        lowTwoDisplay.AddItem (lowTime)
    End If
    
    If timerNumber = 1 Then
        dutyOneDisplay.AddItem (dutyCycle)
    ElseIf timerNumber = 2 Then
        dutyTwoDisplay.AddItem (dutyCycle)
    End If
    
    ReadDutyCycle = 0

End Function

Private Sub Form_Load()
    
    On Error GoTo ErrorMessage
    
    Dim lngError As Long
    Dim strError As String
    Dim lngGetNextIteration As Long
    Dim lngIOType As Long
    lngIOType = 0
    Dim dblValue As Double
    dblValue = 0
    Dim lngHandle As Long
    lngHandle = 0
    Dim resetCounter As Long
    resetCounter = 1
    Dim count As Double
    Dim lngChannel As Long
    count = -1


    'Open the LabJack UE9.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'errorcode = OpenLabJack (LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, Handle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Disable all timers and counters to put everything in a known initial state.
    'Disable the timer and counter, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 0, 0, 0)
    lngError = GoOne(lngHandle)


    'Output a PWM output on Timer0 (FIO0) and measure
    'the duty cycle on Timer1 FIO1 and Timer2 FIO2.

    'Use the fixed 750kHz timer clock source.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc750KHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the divisor to 3 so the actual timer clock is 250kHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Enable 2 timers.  They will use FIO0 and FIO1.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 50%.  The passed value is the low time.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Configure Timer1 and Timer2 as duty cycle measurement.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmDUTYCYCLE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 2, LJ_tmDUTYCYCLE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000


    'Get all the results just to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    While (lngError < LJE_MIN_GROUP_ERROR)
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        If lngError <> LJE_NO_MORE_DATA_AVAILABLE Then
            If lngError <> 0 Then Err.Raise lngError + 50000
        End If
    Wend

    'Set the PWM duty cycle to 25%.  The passed value is the low time.
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 49152, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Now we will reset the duty cycle input timers, so we are sure the
    'reads we do are not old values from before the PWM output was updated.
    Sleep (10)
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Wait a little so we are sure a duty cycle measurement has occured.
    Sleep (10)

    'Read from Timer1.
    lngError = ReadDutyCycle(lngHandle, 1)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Read from Timer2.
    lngError = ReadDutyCycle(lngHandle, 2)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 0%.  The passed value is the low time.
    'We are specifying 65535 out of 65536 clicks to be low.  Since
    'this is 8-bit PWM, we actually get 255 low clicks out of 256 total
    'clicks, so the minimum duty cycle is 0.4%.
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 65535, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Now we will reset the duty cycle input timers, so we are sure the
    'reads we do are not old values from before the PWM output was updated.
    Sleep (10)
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Wait a little so we are sure a duty cycle measurement has occured.
    Sleep (10)

    'Read from Timer1.
    lngError = ReadDutyCycle(lngHandle, 1)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Read from Timer2.
    lngError = ReadDutyCycle(lngHandle, 2)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Set the PWM duty cycle to 100%.  The passed value is the low time.
    'We are specifying 0 out of 65536 clicks to be low, so the signal
    'will be high the entire time, meaning there are no edges
    'for the input timers to detect, and no measurement should be made.
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    'Now we will reset the duty cycle input timers, so we are sure the
    'reads we do are not old values from before the PWM output was updated.
    Sleep (10)
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = ePut(lngHandle, LJ_ioPUT_TIMER_VALUE, 2, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Wait a little so we are sure a duty cycle measurement has been attempted.
    Sleep (10)

    'Read from Timer1.
    lngError = ReadDutyCycle(lngHandle, 1)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Read from Timer2.
    lngError = ReadDutyCycle(lngHandle, 2)
    If lngError <> 0 Then Err.Raise lngError + 50000

    'Disable all timers and counters, and the FIO lines will return to digital I/O.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 1, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub
