VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7740
   LinkTopic       =   "Form1"
   ScaleHeight     =   6615
   ScaleWidth      =   7740
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDutyCycle 
      Height          =   285
      Left            =   4440
      TabIndex        =   16
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtHighTicks 
      Height          =   285
      Left            =   1560
      TabIndex        =   14
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtLowTicks 
      Height          =   285
      Left            =   3000
      TabIndex        =   12
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtTimer3 
      Height          =   285
      Left            =   120
      TabIndex        =   10
      Text            =   "0"
      Top             =   4560
      Width           =   1095
   End
   Begin VB.TextBox txtTimer2 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0"
      Top             =   3840
      Width           =   1095
   End
   Begin VB.TextBox txtTimer1 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Text            =   "0"
      Top             =   3120
      Width           =   1095
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   1800
      TabIndex        =   4
      Text            =   "0"
      Top             =   2160
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.Label Label9 
      Caption         =   "dutyCycle [%]"
      Height          =   495
      Left            =   4440
      TabIndex        =   17
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Label Label8 
      Caption         =   "highTicks"
      Height          =   495
      Left            =   1560
      TabIndex        =   15
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Label Label7 
      Caption         =   "lowTicks"
      Height          =   495
      Left            =   3000
      TabIndex        =   13
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Timer3"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   4320
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Timer2"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   3600
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "Timer1"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   2880
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   1800
      TabIndex        =   5
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   1320
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Period timing example to interface with the LabJackUD driver.
'Outputs a PWM signal on FIO0.
'Measures duty cycle on FIO1.
'Measures period on FIO2 (32-bit).
'Measures period on FIO3 (16-bit).
'Use jumper wires to short FIO0-FIO3 together for this example.

'support@labjack.com
'Nov 2, 2006

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim strError As String * 256
    Dim dblTimer1 As Double
    Dim dblTimer2 As Double
    Dim dblTimer3 As Double
    Dim dutyCycle As Double
    Dim highTicks As Double
    Dim lowTicks As Double
    
    On Error GoTo ErrorMessage
        
       
    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'Open the LabJack UE9 over Ethernet.
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    
    'Configuration block.
    
    'Use the fixed 750kHz timer clock base.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc750KHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the divisor to 3 so the actual timer clock is 250kHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Enable 4 timers.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 4, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the PWM duty cycle to 25%.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 49152, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer1 as duty-cycle input.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 1, LJ_tmDUTYCYCLE, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer2 as 32-bit period input.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 2, LJ_tmRISINGEDGES32, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer3 as 16-bit period input.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 3, LJ_tmRISINGEDGES16, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"

    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
      
    'Instead of GetResult, we will demonstrate the use of GetFirst/GetNext
    'to read these results.  All of the requests were writes, so the only
    'reason we get the results is to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    Do Until lngError
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        'If we had data to read, we could use if statements in here to watch
        'for the desired results, such as:
        'If ((lngIOType = LJ_ioGET_AIN) And (lngChannel = 2)) Then Value2 = dblValue
    Loop
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'Wait a second, then read the timers.
    Sleep 1000
    
    'Add requests.
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 1, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 2, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioGET_TIMER, 3, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Execute requests.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get results.
    lngError = GetResult(lngHandle, LJ_ioGET_TIMER, 1, dblTimer1)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtTimer1 = Str(dblTimer1)
    lngError = GetResult(lngHandle, LJ_ioGET_TIMER, 2, dblTimer2)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtTimer2 = Str(dblTimer2)
    lngError = GetResult(lngHandle, LJ_ioGET_TIMER, 3, dblTimer3)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtTimer3 = Str(dblTimer3)
    
    'Both period measurements should read about 256.  The timer
    'clock was set to 250 kHz, so each tick equals 4 microseconds, so
    '256 ticks means a period of 1024 microseconds which is a frequency
    'of 977 Hz.
    
    'The PWM duty-cycle was set to 25%, so the duty-cycle input should
    'read about 64 high ticks and 192 low ticks.
    
    'High time is LSW
    highTicks = dblTimer1 Mod 65536
    txtHighTicks = Str(highTicks)
    'Low time is MSW
    lowTicks = dblTimer1 \ 65536
    txtLowTicks = Str(lowTicks)
    'Calculate the duty cycle percentage.
    dutyCycle = 100 * highTicks / (highTicks + lowTicks)
    txtDutyCycle = Str(dutyCycle)
        
    'Disable the timers.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number-50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


