VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6615
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3990
   LinkTopic       =   "Form1"
   ScaleHeight     =   6615
   ScaleWidth      =   3990
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtMACAddress 
      Height          =   285
      Left            =   120
      TabIndex        =   18
      Text            =   "0"
      Top             =   3960
      Width           =   1935
   End
   Begin VB.TextBox txtIPAddress 
      Height          =   285
      Left            =   120
      TabIndex        =   16
      Text            =   "0"
      Top             =   3360
      Width           =   1335
   End
   Begin VB.TextBox txtSerialNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   14
      Text            =   "0"
      Top             =   2760
      Width           =   1335
   End
   Begin VB.TextBox txtCount0 
      Height          =   285
      Left            =   120
      TabIndex        =   12
      Text            =   "0"
      Top             =   6120
      Width           =   1095
   End
   Begin VB.TextBox txtFIO3 
      Height          =   285
      Left            =   120
      TabIndex        =   10
      Text            =   "0"
      Top             =   5400
      Width           =   1095
   End
   Begin VB.TextBox txtAIN1 
      Height          =   285
      Left            =   120
      TabIndex        =   8
      Text            =   "0.0"
      Top             =   4680
      Width           =   1935
   End
   Begin VB.TextBox txtOpenErrorString 
      Height          =   285
      Left            =   120
      TabIndex        =   6
      Text            =   "0"
      Top             =   960
      Width           =   3495
   End
   Begin VB.TextBox txtOpenErrorNumber 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "0"
      Top             =   2160
      Width           =   1095
   End
   Begin VB.TextBox txtHandle 
      Height          =   285
      Left            =   120
      TabIndex        =   2
      Text            =   "0"
      Top             =   1560
      Width           =   1095
   End
   Begin VB.TextBox txtDriverVersion 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "0.0"
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label9 
      Caption         =   "MAC Address"
      Height          =   495
      Left            =   120
      TabIndex        =   19
      Top             =   3720
      Width           =   1215
   End
   Begin VB.Label Label8 
      Caption         =   "IP Address (Decimal Dot Notation)"
      Height          =   495
      Left            =   120
      TabIndex        =   17
      Top             =   3120
      Width           =   2655
   End
   Begin VB.Label Label7 
      Caption         =   "Serial Number"
      Height          =   495
      Left            =   120
      TabIndex        =   15
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Count0"
      Height          =   495
      Left            =   120
      TabIndex        =   13
      Top             =   5880
      Width           =   1215
   End
   Begin VB.Label Label6 
      Caption         =   "FIO3"
      Height          =   495
      Left            =   120
      TabIndex        =   11
      Top             =   5160
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "AIN1"
      Height          =   495
      Left            =   120
      TabIndex        =   9
      Top             =   4440
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Open Error String"
      Height          =   495
      Left            =   120
      TabIndex        =   7
      Top             =   720
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Open Error Number"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   1920
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Handle"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label LabelCount 
      Caption         =   "Driver Version"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Simple VB example to interface with the LabJackUD driver.
'support@labjack.com
'Jan 10, 2006

'We have made a VB module for the LabJackUD driver.  You need to
'include this module in any project that will talk to the LabJackUD
'driver.  Similar to a header file in C, this module declares the
'functions and constants.  In the "Project" window pane, do Add=>Module
'and add LabJackUD_VB.bas to the project.

'Declare the Windows API Sleep function, which is a very simple way to
'delay for some number of milliseconds.
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

'Not sure if there is any reason not to do Option Explicit.  It helps
'avoid typo related errors.
Option Explicit

Private Sub Form_Load()
    
    Dim lngError As Long
    Dim lngHandle As Long
    Dim lngIOType As Long
    Dim lngChannel As Long
    Dim dblValue As Double
    Dim dblDriverVersion As Double
    Dim strError As String * 256
    Dim dblSerialNumber As Double
    Dim dblIPAddress As Double
    Dim strIPAddress As String * 16
    Dim dblMACAddress As Double
    Dim dblAIN0 As Double
    Dim dblAIN1 As Double
    Dim dblFIO3 As Double
    Dim dblCount0 As Double
    
    On Error GoTo ErrorMessage
        
        
    'Retrieve the LabJackUD driver version.
    dblDriverVersion = GetDriverVersion()
    txtDriverVersion = Str(dblDriverVersion)
    
   
    'Open the first found LabJack UE9 over USB.
    lngError = OpenLabJack(LJ_dtUE9, LJ_ctUSB, "1", 1, lngHandle)
    'Open the LabJack UE9 over Ethernet.
    'lngError = OpenLabJack(LJ_dtUE9, LJ_ctETHERNET, "192.168.1.209", 0, lngHandle)
    txtHandle = Str(lngHandle)
    txtOpenErrorNumber = Str(lngError)
    'Convert the error code to a string.
    ErrorToString lngError, strError
    txtOpenErrorString = strError
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'First, examples using eGet():
    'Read and display the serial number.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chSERIAL_NUMBER, dblSerialNumber, 0)
    txtSerialNumber = Str(dblSerialNumber)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Read and display the IP address.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chIP_ADDRESS, dblIPAddress, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = DoubleToStringAddress(dblIPAddress, strIPAddress, 0)  'Hexdot not implemented yet
    txtIPAddress = strIPAddress
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Read and display the MAC address.
    lngError = eGet(lngHandle, LJ_ioGET_CONFIG, LJ_chMACADDRESS, dblMACAddress, 0)
    txtMACAddress = Str(dblMACAddress) 'conversion function not implemented for MAC, so just display decimal value
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'The next 3 calls set configuration parameters that the DLL
    'will store until changed.
    'Configure analog inputs for 16-bit resolution
    lngError = eGet(lngHandle, LJ_ioPUT_CONFIG, LJ_chAIN_RESOLUTION, 16, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure the analog input range on channels 0 and 1 for bipolar +-5 volts.
    lngError = eGet(lngHandle, LJ_ioPUT_AIN_RANGE, 0, LJ_rgBIP5V, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = eGet(lngHandle, LJ_ioPUT_AIN_RANGE, 1, LJ_rgBIP5V, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get a reading from AIN1.
    lngError = eGet(lngHandle, LJ_ioGET_AIN, 1, dblAIN1, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the state of FIO3.
    lngError = eGet(lngHandle, LJ_ioGET_DIGITAL_BIT, 3, dblFIO3, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set DAC0 to 2.5 volts.
    lngError = eGet(lngHandle, LJ_ioPUT_DAC, 0, 2.5, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the state of FIO2 to output-high.
    lngError = eGet(lngHandle, LJ_ioPUT_DIGITAL_BIT, 2, 1, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    txtAIN1 = Format(dblAIN1, "#.#####")
    txtFIO3 = Str(dblFIO3)
    
    
    'Now, examples using AddRequest/GoOne/GetResult.  This method can
    'have a speed advantage, as multiple requests can be handled in
    'a single low level command:
    'The resolution and ranges configured above are still in effect.
    'Request a reading from AIN0 and AIN1.
    lngError = AddRequest(lngHandle, LJ_ioGET_AIN, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioGET_AIN, 1, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Request the state of FIO3.
    lngError = AddRequest(lngHandle, LJ_ioGET_DIGITAL_BIT, 3, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Request to set DAC0 to 2.5 volts.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DAC, 0, 2.5, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Request to set the state of FIO2 to output-high.
    lngError = AddRequest(lngHandle, LJ_ioPUT_DIGITAL_BIT, 2, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level Feedback command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the analog input voltage readings.
    lngError = GetResult(lngHandle, LJ_ioGET_AIN, 0, dblAIN0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = GetResult(lngHandle, LJ_ioGET_AIN, 1, dblAIN1)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the state of FIO3.
    lngError = GetResult(lngHandle, LJ_ioGET_DIGITAL_BIT, 3, dblFIO3)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the DAC request result just to check for an errorcode.
    lngError = GetResult(lngHandle, LJ_ioPUT_DAC, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the digital output request result just to check for an errorcode.
    lngError = GetResult(lngHandle, LJ_ioPUT_DIGITAL_BIT, 2, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'The requests can be executed repeatedly, as the request list remains
    'in effect until AddRequest is called again:
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Get the analog input voltage readings again.
    lngError = GetResult(lngHandle, LJ_ioGET_AIN, 0, dblAIN0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = GetResult(lngHandle, LJ_ioGET_AIN, 1, dblAIN1)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
     
        
         
    'Now a timer and counter example.  Connect a jumper on
    'the UE9 from FIO0 (PWM output) to FIO1 (Counter0 input).
    'Use the fixed 750kHz timer clock base.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_BASE, LJ_tc750KHZ, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the divisor to 3 so the actual timer clock is 250kHz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chTIMER_CLOCK_DIVISOR, 3, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Enable 1 timer.  It will use FIO0.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Configure Timer0 as 8-bit PWM.  Frequency will be 250k/256 = 977 Hz.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_MODE, 0, LJ_tmPWM8, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Set the PWM duty cycle to 50%.
    lngError = AddRequest(lngHandle, LJ_ioPUT_TIMER_VALUE, 0, 32768, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Enable Counter0.  It will use FIO1 since 1 timer is enabled.
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 1, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    'Execute the requests on a single LabJack.  The driver will use a
    'single low-level TimerCounter command to handle all the requests above.
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
      
    'Instead of GetResult, we will demonstrate the use of GetFirst/GetNext
    'to read these results.  All of the requests were writes, so the only
    'reason we get the results is to check for errors.
    lngError = GetFirstResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    Do Until lngError
        lngError = GetNextResult(lngHandle, lngIOType, lngChannel, dblValue, 0, 0)
        'If we had data to read, we could use if statements in here to watch
        'for the desired results, such as:
        'If ((lngIOType = LJ_ioGET_AIN) And (lngChannel = 2)) Then Value2 = dblValue
    Loop
    If lngError = LJE_NO_MORE_DATA_AVAILABLE Then lngError = 0
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    
    
    'Wait half a second, then read Counter0.  Should get roughly 488 counts.
    Sleep 500
    lngError = eGet(lngHandle, LJ_ioGET_COUNTER, 0, dblCount0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    txtCount0 = Str(dblCount0)
        
    'Disable the timer and counter.
    lngError = AddRequest(lngHandle, LJ_ioPUT_CONFIG, LJ_chNUMBER_TIMERS_ENABLED, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = AddRequest(lngHandle, LJ_ioPUT_COUNTER_ENABLE, 0, 0, 0, 0)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
    lngError = GoOne(lngHandle)
    If lngError <> 0 Then Err.Raise lngError + 50000 'Adding 50000 makes sure Labjack errors are recognized by VB as "user-defined"
        
    Exit Sub
    
    
    
ErrorMessage:
    If Err.Number > 50000 Then ' If this is a labjack error
        ErrorToString Err.Number - 50000, strError
        MsgBox "Function returned LabJackUD Error #" & _
            Str$(Err.Number - 50000) & _
            "  " & _
            strError
        'Stop the stream
        lngError = eGet(lngHandle, LJ_ioSTOP_STREAM, 0, 0, 0)
    ElseIf Err.Number > 0 Then 'VB error
        MsgBox "VB error: Error #" & _
            Str$(Err.Number) & _
            "  " & _
            strError
    End If
    Exit Sub
        
End Sub


